
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>GIt分支管理策略 / 憋错料</title>

    <meta name="description" content="GIt分支管理策略 大纲: 1.前言 2.创建分支 3.切换分支 4.合并分支(快速合并) 5.删除分支 6.分支合并冲突 7.合并分支(普通合并) 8.分支管理策略 9.团队多人开发协作 10.总结 注,测试机 CentOS 5.5 x86_64,Git 服务器版本:git version 1.8.2.1,客户端版本:git version 1.9.2.msysgit.0.所有软件请到这里下载:http://msysgit.github.io/. 1.前言 在上一篇博客中我们主要讲解了Git 远程仓库,相信大家对">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">GIt分支管理策略</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><em></em></p>
<h3>大纲：</h3>
<p>1.前言</p>
<p>2.创建分支</p>
<p>3.切换分支</p>
<p>4.合并分支（快速合并）</p>
<p>5.删除分支</p>
<p>6.分支合并冲突</p>
<p>7.合并分支（普通合并）</p>
<p>8.分支管理策略</p>
<p>9.团队多人开发协作</p>
<p>10.总结</p>
<p>注，测试机 CentOS 5.5 x86_64，Git 服务器版本：git version 1.8.2.1，客户端版本：git version 1.9.2.msysgit.0。所有软件请到这里下载：http://msysgit.github.io/。</p>
<h3>1.前言</h3>
<p>在上一篇博客中我们主要讲解了Git 远程仓库，相信大家对远程的Git仓库有一定的了解，嘿嘿。在这一篇博客中我们来在大家讲解一下Git 分支管理，这可以说是Git的又一大特点。下面我们就来学习一下Git分支管理吧。</p>
<p>我们先来说一个简单的案例吧，你们团队中有多个人再开发一下项目，一同事再开发一个新的功能，需要一周时间完成，他写了其中的30%还没有写完，如果他提 交了这个版本，那么团队中的其它人就不能继续开发了。但是等到他全部写完再全部提交，大家又看不到他的开发进度，也不能继续干活，这如何是好呢？</p>
<p>对于上面的这个问题，我们就可以用分支管理的办法来解决，一同事开发新功能他可以创建一个属于他自己的分支，其它同事暂时看不到，继续在开发分支（一般都 有多个分支）上干活，他在自己的分支上干活，等他全部开发完成，再一次性的合并到开发分支上，这样我们既可知道他的开发进度，又不影响大家干活，是不是很 方便呢？</p>
<p>大家可能会说了，你Git的分支功能人家SVN也有啊，也没什么特殊的嘛。但我想说你那个创建和切换速度怎么样呢？嘿嘿，我想说谁用谁知道啊！但Git呢，无论你创建还是切换或者删除都很快哦！</p>
<p>分支本质上其实就是一个指向某次提交的可变指针。Git 的默认分支名字为 master 。而我们是怎么知道当前处于哪个分支当中呢？答案就是在于 HEAD 这个十分特殊的指针，它专门用于指向于本地分支中的当前分支。我们可以简单理解为：commit &lt;- branch &lt;- HEAD （注，本来我们详细说一下HEAD的，这个东西真不好说，goole了一下也没几个大神说这个，嘿嘿。下面我就通过讲解帮助大家理解，简单的说HEAD就 是指向于本地分支中的当前分支，如下图：） 下面我们来创建分支。</p>
<h3>2.创建分支</h3>
<p>当我们需要调试某个Bug或者尝试添加或修改程序中的某个模块，而又不能影响主分支的开发时。就可以通过创建分支来满足需求。创建分支相当于是创建一个新的分支指针指向当前所在的提交。我们在Commit3上创建dev分支：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNF9hSjVILnBuZw==.jpg" /></p>
<p>如下图所示，dev分支指向Commit3。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNF9mS3pxLnBuZw==.jpg" /></p>
<p>从上图可知，虽然我们创建了一个新分支，但是 HEAD 仍然指向 master 。如果希望在创建分支的同时切换到新分支上，我们可以通过以下命令实现：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNF9GUGlNLnBuZw==.jpg" /></p>
<p>git checkout命令加上-b参数表示创建并切换分支上。</p>
<h3>3.切换分支</h3>
<p>切换当前分支我们可以用以下命令实现：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNF9YU0lCLnBuZw==.jpg" /></p>
<p>git branch -a 命令可以查看所有分支，现在我们HEAD指针便指向dev分支，大家可以在上图中看到dev分支上有个*号。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNF9BZzZCLnBuZw==.jpg" /></p>
<p>下面我们修改一下readme.txt中的内容，并在dev分支上提交一下。如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNF9QOXBXLnBuZw==.jpg" /></p>
<p>用流程图演示上述过程如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNV8waUttLnBuZw==.jpg" /></p>
<p>现在我们在dev分支上完成工作，现在到master分支上。如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNV8wN1RhLnBuZw==.jpg" /></p>
<p>流程图表示如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNV9OUHRWLnBuZw==.jpg" /></p>
<p>切换回master分支后，再查看一个readme.txt文件，如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNV9pSWQzLnBuZw==.jpg" /></p>
<p>大家可以看到我们刚才增加的一行内容不见了，嘿嘿。因为那个提交是在dev分支上，而master分支没有变化。好了，下面我们来演示一下合并分支。</p>
<h3>4.合并分支（快速合并）</h3>
<p>现在，我们把dev分支的工作成果合并到master分支上，如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNV9iYXlHLnBuZw==.jpg" /></p>
<p>git merge 命令用于合并指定分支到当前分支。合并后，再查看readme.txt的内容，就可以看到，和dev分支的最新提交是完全一样的。如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNV83eWN4LnBuZw==.jpg" /></p>
<p>大家注意到上面的Fast-forward信息，Git告诉我们，这次合并是&ldquo;快进模式&rdquo;，也就是直接把master指向dev的当前提交，所以合并速度 非常快。当然，也不是每次合并都能Fast-forward，我们后面会将其他方式的合并。合并完成后，就可以放心地删除dev分支了。</p>
<h3>5.删除分支</h3>
<p>下面我们来演示一下删除分支，如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNV9IMDJ0LnBuZw==.jpg" /></p>
<p>大家在实际操作中可以发现在我们创建、合并、删除分支的速度非常快吧，这和直接在master分支上工作效果是一样的，但过程更安全，更可靠。下面我们来简单的总结一下：</p>
<ul>
<li>查看分支 git branch -a</li>
<li>创建分支 git branch name</li>
<li>切换分支 git checkout name</li>
<li>创建并切换 git checkout -b name</li>
<li>合并某分支到当前分支 git merge name</li>
<li>删除分支 git branch -d name</li>
</ul>
<h3>6.分支合并冲突</h3>
<p>下面我们来演示一下不同分支修改同一个文件产生冲突问题，下面我们来创建一个新的分支，继续开发新功能：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNV9tbDY3LnBuZw==.jpg" /></p>
<p>现在我们将分支切换到master分支上修改readme.txt内容并提交，如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNV9CWVBLLnBuZw==.jpg" /></p>
<p>这种情况下，Git无法执行&ldquo;快速合并&rdquo;，只能试图把各自的修改合并起来，但这种合并就可能会有冲突，如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNV82bXhaLnBuZw==.jpg" /></p>
<p>果然冲突了，Git告诉我们readme.txt文件存在冲突，必须手动解决冲突后再提交。下面我们用git status查看一下状态：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNV92Wm5CLnBuZw==.jpg" /></p>
<p>下面我们来查看一下readme.txt中的内容，如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNV9mZ01RLnBuZw==.jpg" /></p>
<p>Git用&lt;&lt;&lt;&lt;&lt;&lt;&lt;，=======，&gt;&gt;&gt;&gt;&gt;&gt;&gt;标记出不同分支的内容，让我们选择要保留的内容，下面我们修改一下readme.txt，再次提交。如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNV93S2hFLnBuZw==.jpg" /></p>
<p>好了，到这我们的分支合并冲突就讲解完成了，下面我们来删除分支。如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNl81WE5FLnBuZw==.jpg" /></p>
<p>最后，我们可以用 git log --graph --pretty=oneline --abbrev-commit 命令，查看一下分支合并。</p>
<h3>7.合并分支（普通合并）</h3>
<p>分支合并分为快速合并与普通合并两种模式，普通合并，合并后的历史有分支记录，能看出来曾经做过合并，而快速合并就看不出来曾经做过合并。下面我们来演示一下普通合并，</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNl9YMXluLnBuZw==.jpg" /></p>
<p>大家可以看到我们这次合并用的普通模式合并，--no-ff参数表示禁用快速合并。下面我们用git log命令查看一下合并历史：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNl9ybUpULnBuZw==.jpg" /></p>
<p>注，合并分支时，加上--no-ff参数就可以用普通模式合并，合并后的历史有分支记录，能看出来曾经做过合并，而fast forward合并就看不出来曾经做过合并。如下图：</p>
<p><strong>1).快速合并</strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNl9wV0Y1LnBuZw==.jpg" /></p>
<p><strong>2).普通合并</strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNl90MTl0LnBuZw==.jpg" /></p>
<h3>8.分支管理策略</h3>
<p>下面我们来说一下一般企业中开发一个项目的分支策略：</p>
<ul>
<li>主分支 master</li>
<li>开发分支 develop</li>
<li>功能分支 feature</li>
<li>预发布分支&nbsp; release</li>
<li>bug&nbsp;分支 fixbug</li>
<li>其它分支 other</li>
</ul>
<p><strong>1).主分支 master</strong></p>
<p>代码库应该有一个、且仅有一个主分支。所有提供给用户使用的正式版本，都在这个主分支上发布。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNl9KZnA4LnBuZw==.jpg" /></p>
<p>Git主分支的名字，默认叫做Master。它是自动建立的，版本库初始化以后，默认就是在主分支在进行开发。</p>
<p><strong>2).开发分支 develop</strong></p>
<p>主分支只用来分布重大版本，日常开发应该在另一条分支上完成。我们把开发用的分支，叫做Develop。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNl9IWVZtLnBuZw==.jpg" /></p>
<p>这个分支可以用来生成代码的最新代码版本。如果想正式对外发布，就在Master分支上，对Develop分支进行"合并"（merge）。</p>
<p><strong>3).功能分支 feature</strong></p>
<p>功能分支，它是为了开发某种特定功能，从Develop分支上面分出来的。开发完成后，要再并入Develop。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNl92MnZlLnBuZw==.jpg" /></p>
<p>功能分支的名字，可以采用feature-*的形式命名。</p>
<p><strong>4).预发布分支&nbsp; release</strong></p>
<p>预发布分支，它是指发布正式版本之前（即合并到Master分支之前），我们可能需要有一个预发布的版本进行测试。预发布分支是从Develop分支上面 分出来的，预发布结束以后，必须合并进Develop和Master分支。它的命名，可以采用release-*的形式。</p>
<p><strong>5).bug 分支 fixbug</strong></p>
<p>bug分支。软件正式发布以后，难免会出现bug。这时就需要创建一个分支，进行bug修补。修补bug分支是从Master分支上面分出来的。修补结束以后，再合并进Master和Develop分支。它的命名，可以采用fixbug-*的形式。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNl9QSWYxLnBuZw==.jpg" /></p>
<p><strong>6).其它分支 other</strong></p>
<p>还有就是其它分支了，大家可以根据需要创建即可&hellip;&hellip;</p>
<h3>9.团队多人开发协作</h3>
<p>在上面的章节中我们讲解了Git的分支管理策略，一般开发团队中有这样几个分支，master、develop、feature、release、 bug、other分支，或者你还有其它分支，那有博友会问了，你讲了那么多分支，都在本地放着我们怎么查看和推送分支到远程服务器上呢？嘿嘿，我们说大 家别急我们在这一章节中就来重点讲解，在团队多人协作中的分支推送与抓取。</p>
<p><strong>1).查看远程仓库分支</strong></p>
<p>查看远程仓库的信息，如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNl9MRmRpLnBuZw==.jpg" /></p>
<p>大家可以看到git remote命令可以查看远程仓库，加-v选项可以查看详细信息。上面显示了你抓取和推送的origin（源）信息。 当你从远程仓库克隆时，实际上Git自动把本地的master分支和远程的master分支对应起来了，并且远程仓库的默认名称是origin。</p>
<p><strong>2).分支推送</strong></p>
<p>下面我们来演示一下将本地分支推送到远程的仓库中，如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxNl9uRFYyLnBuZw==.jpg" /></p>
<p>大家可以看到，我们的本地master分支与远程的master分支已同步。下面我们来演示一下同步dev分支，如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxN19VeHA5LnBuZw==.jpg" /></p>
<p>有博友会问了，我本地有很多分支，有哪些分支需要推送到远程仓库中呢？一般是这样的，</p>
<ul>
<li>master 分支是主分支，要时刻与远程同步，一般我们发布最新版本就用master分支</li>
<li>develop 分支是开发分支，团队中所有人都在这个分支上开发，所以也需要与远程同步</li>
<li>bug 分支一般只在本地使用来修复bug，一般不需推送远程仓库中</li>
<li>feature 分支是否需要推送到远程，要看是不是有几个人合作开发新功能，如果你是一个开发，那就留在本地吧</li>
<li>release 分支一般是系统管理，推送或抓取的分支一般与开发人员无关</li>
<li>other 分支大家按需求分配</li>
</ul>
<p><strong>3).分支抓取</strong></p>
<p>现在你一同事在电脑上克隆一份仓库，我们来演示一下。</p>
<p>生成公钥：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxN19LdmRpLmpwZw==.jpg" /></p>
<p>将生成的公司增加到git服务器上：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxN19odHFsLmpwZw==.jpg" /></p>
<p>克隆远程版本库：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxN19JVkNNLmpwZw==.jpg" /></p>
<p>我们现在查看一下分支：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxN19POUJ0LmpwZw==.jpg" /></p>
<p>你同事要在dev分支上开发，就得创建与远程origin一样的dev分支到本地的仓库上，下面我们来创建一下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxN190ODhSLmpwZw==.jpg" /></p>
<p>现在你同事就可以在dev分支上开发了，下面我们新建一些文件并提交到远程dev分支：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxOF94RU5oLmpwZw==.jpg" /></p>
<p>你的同事向origin/dev分支提交了一个index.html页面，现在你也在修改这个文件，并提交：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxOF83WDRkLnBuZw==.jpg" /></p>
<p>推送失败，因为你同事的最新提交和你推送的提交有冲突，Git提示我们，先用git pull把最新的提交从origin/dev抓下来，然后在本地合并解决冲突，再推送：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxOF9BS2JxLnBuZw==.jpg" /></p>
<p><em>git pull 失败了，原因是没有将dev分支与远程origin/dev分支进行链接，Git提示我们设置dev和origin/dev的链接：</em></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxOF9DUjZ5LnBuZw==.jpg" /></p>
<p>下面我们再来git pull一下试试：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxOF9IaFRJLnBuZw==.jpg" /></p>
<p>git pull 成功，但是合并有冲突需要手动解决，解决的方法和分支管理中的解决冲突完全一样。解决后提再push：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxOF84MVYwLnBuZw==.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxOF9BdWo5LnBuZw==.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTQwNi8wNTExMjAxOF9iWEFjLnBuZw==.jpg" /></p>
<p>好了，这样的我们的远程推送与抓取就讲解完成了，下面我们来总结一下。</p>
<h3>10.总结</h3>
<p>一般在团队中多人开发模式是这样的：首先，可以试图用git push origin branch-name推送自己的修改如果推送失败，则因为远程分支比你的本地更新，需要先用git pull试图合并如果合并有冲突，则解决冲突，并在本地提交没有冲突或者解决掉冲突后，再用git push origin branch-name推送就能成功如果git pull提示&ldquo;no tracking information&rdquo;，则说明本地分支和远程分支的链接关系没有创建，用命令git branch --set-upstream branch-name origin/branch-name。</p>
<p>好了，到这里我们的Git分支管理就讲解到这里了。最后，希望大家有所收获^_^&hellip;&hellip;</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-28 18:16:57 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>GIt分支管理策略的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pGZbP3.html" rel="bookmark">&lbrack;转&rsqb;Git分支管理策略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果你严肃对待编程,就必定会使用&quot;版本管理系统&quot;(Version Control System). 眼下最流行的&quot;版本管理系统&quot;,非Git莫属. 相比同类软件,Git有很多优点.其中很显著的一点,就是版本的分支(branch)和合并(merge)十分方便.有些传统的版本管理软件,分支操作实际上会生成一份现有代码的物理拷贝,而Git只生成一个指向当前版本(又称&quot;快照&quot;)的指针,因此非常快捷易用. 但是,太方便了也会产生副作用.如果你不加注意,很可能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0b1PxYM.html" rel="bookmark">Git工程开发实践（四）&mdash;&mdash;Git分支管理策略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Git工程开发实践(四)--Git分支管理策略 一.Git版本管理的挑战 Git是非常优秀的版本管理工具,但面对版本管理依然有非常大得挑战.工程开发中,开发者彼此的代码协作必然带来很多问题和挑战:A.如何开始一个Feature开发,而不影响其它Feature?B.由于很容易创建新分支,分支多了如何管理,时间久了,如何知道每个分支是干什么的?C.哪些分支已经合并回了主干?D.如何进行Release的管理?开始一个Release的时候如何冻结Feature, 如何在Prepare Release的时			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/74QNvLM.html" rel="bookmark">&lbrack;廖雪峰&rsqb; Git 分支管理策略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				通常,合并分支时,如果可能,Git 会用 Fast forward 模式,但这种模式下,删除分支后,会丢掉分支信息. 如果要强制 禁用 Fast forward 模式,Git 就会在 merge 时生成一个新的 commit,这样,从分支历史上就可以看出分支信息. 下面我们实战一下 --no-ff 方式的 git merge: 首先,仍然创建并切换 dev 分支: $ git checkout -b dev Switched to a new branch 'dev' 修改 readme.txt			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bg1zm3.html" rel="bookmark">Git分支管理策略&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果你严肃对待编程,就必定会使用&quot;版本管理系统&quot;(Version Control System). 眼下最流行的&quot;版本管理系统&quot;,非Git莫属. 相比同类软件,Git有很多优点.其中很显著的一点,就是版本的分支(branch)和合并(merge)十分方便.有些传统的版本管理软件,分支操作实际上会生成一份现有代码的物理拷贝,而Git只生成一个指向当前版本(又称&quot;快照&quot;)的指针,因此非常快捷易用. 但是,太方便了也会产生副作用.如果你不加注意,很可能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pQ2OxM.html" rel="bookmark">Git分支管理策略（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果你严肃对待编程,就必定会使用&quot;版本管理系统&quot;(Version Control System). 眼下最流行的&quot;版本管理系统&quot;,非Git莫属. 相比同类软件,Git有很多优点.其中很显著的一点,就是版本的分支(branch)和合并(merge)十分方便.有些传统的版本管理软件,分支操作实际上会生成一份现有代码的物理拷贝,而Git只生成一个指向当前版本(又称&quot;快照&quot;)的指针,因此非常快捷易用. 但是,太方便了也会产生副作用.如果你不加注意,很可能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0K1bEj4.html" rel="bookmark">梳理git分支管理策略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果你严肃对待编程,就必定会使用&quot;版本管理系统&quot;(Version Control System). 眼下最流行的&quot;版本管理系统&quot;,非Git莫属. 相比同类软件,Git有很多优点.其中很显著的一点,就是版本的分支(branch)和合并(merge)十分方便.有些传统的版本管理软件,分支操作实际上会生成一份现有代码的物理拷贝,而Git只生成一个指向当前版本(又称&quot;快照&quot;)的指针,因此非常快捷易用. 但是,太方便了也会产生副作用.如果你不加注意,很可能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3v5Ank0.html" rel="bookmark">git分支管理与冲突解决&lpar;转载&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Git 分支管理和冲突解决 原文:http://www.cnblogs.com/mengdd/p/3585038.html 创建分支 git branch 没有参数,显示本地版本库中所有的本地分支名称. 当前检出分支的前面会有星号. git branch newname 在当前检出分支上新建分支,名叫newname. git checkout newname 检出分支,即切换到名叫newname的分支. git checkout –b newname master 这个命令将上面两个命令合并:在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWDaBy0.html" rel="bookmark">分支管理策略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				通常,合并分支时,如果可能,Git会用“Fast forward”模式,但这种模式下,删除分支后,会丢掉分支信息. 如果要强制禁用“Fast forward”模式,Git就会在merge时生成一个新的commit,这样,从分支历史上就可以看出分支信息. 下面我们实战一下--no-ff方式的merge: 首先,仍然创建并切换dev分支: $ git checkout -b dev Switched to a new branch 'dev' 修改readme.txt文件,并提交一个新的commit			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e91Db0.html" rel="bookmark">Git分支管理小结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				分支管理命令 每次提交,Git都把它们串成一条时间线,这条时间线就是一个分支.截止到目前,只有一条时间线,在Git里,这个分支叫主分支,即master分支.HEAD严格来说不是指向提交,而是指向master,master才是指向提交的,所以,HEAD指向的就是当前分支. 查看分支:git branch创建分支:git branch &lt;name&gt; 切换分支:git checkout &lt;name&gt; 创建+切换分支:git checkout -b &lt;name&gt; 合并某分支到当			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n3Z5WL0.html" rel="bookmark" class="title">listview加载网络图片</a>
					<div>
						public class ImageAndTextListAdapter extends ArrayAdapter&lt;ImageAndText&gt; { private ListView lis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/QM6qgX4.html" rel="bookmark" class="title">【转载】Ubuntu 12&period;04 LTS 中文输入法的安装</a>
					<div>
						原文地址 :  http://www.cnblogs.com/zhj5chengfeng/archive/2013/06/23/3150620.html 我装的是英文版的 Ubuntu12.04,如果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzaAqA4.html" rel="bookmark" class="title">Android 推门效果</a>
					<div>
						public class MainActivity extends RelativeLayout{ private Scroller scroller; private Context context ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZVRD83.html" rel="bookmark" class="title">NOIP提高组 2016D1T1 玩具谜题</a>
					<div>
						此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:https://www.luogu.org/problem/show?pid=1563 题目描述 小南有一套可爱的玩具小 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49bxWAM.html" rel="bookmark" class="title">android如何保存读取读取文件文件保存到SDcard</a>
					<div>
						android如何保存读取读取文件文件保存到SDcard 19. 三 / android基础 / 没有评论 本文来源于www.ifyao.com禁止转载!www.ifyao.com 上图为保存文件的方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YX9yWM.html" rel="bookmark" class="title">&lbrack;JS&rsqb;应用splice删除多元素时出现的坑</a>
					<div>
						------------------------------------------------------------------------------------- 先看一个片段: var fr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bgwXv3.html" rel="bookmark" class="title">【转自百度某文】读完有点感觉吧</a>
					<div>
						①.对于你能写这么长的问题描述,说明你很认真. ②.你的目的性较强,但是你也想有更加明确的目标,我可以给你讲一下怎么自己去寻找目标和路线以及怎样学习. ③.计算机专业领域一共有几个大方向,十几个分支方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4p5x7wM.html" rel="bookmark" class="title">如何在线缩小jpg图片的大小</a>
					<div>
						直接使用在线PS保存成更小格式,即可! 在线PS网址:http://www.webps.cn/ 打开图片 点击保存 直接拖动滑动条就可以改变图片大小					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQNjgM.html" rel="bookmark" class="title">&lbrack;转&rsqb;解决LinearLayout中控件不能居右对齐</a>
					<div>
						在LinearLayout布局时使用右对齐(android:layout_gravity=&quot;right&quot;)控件对齐方式不生效,需要设置 android:layout_weight= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0koxm70.html" rel="bookmark" class="title">Codeforces 494B Obsessive String</a>
					<div>
						http://www.codeforces.com/problemset/problem/494/B 题意:给出两个串S,T,求有几种将S分成若干个子串,满足T都是这若干个子串的子串. 思路:f[n] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aRVoP3.html" rel="bookmark" class="title">6&period;文件操作</a>
					<div>
						文件处理流程模式:常用模式字节模式(二进制操作):可读可写模式:操作文件常用文件操作方法seek详解:with----上下文管理器 文件处理 流程 打开文件 open() f = open(filen ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmNAYp0.html" rel="bookmark" class="title">介绍MyEclipse集成Tomcat7，并开发WebSocket的全过程</a>
					<div>
						1.首先使MyEclipse8.6集成Tomcat7 注意配置参数 注意jar包 主机JDK版本 2.开发WebSocket 导入websocket-api.jar 开发java文件 package  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e9zew0.html" rel="bookmark" class="title">mybatise</a>
					<div>
						JDBC public static void main(String[] args) { ResultSet resultSet = null; PreparedStatement prepared ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e6jOv3.html" rel="bookmark" class="title">POJ Stockbroker Grapevine 1125 多源最短路（Floyd）</a>
					<div>
						题目大意: 股票经纪人散播谣言,总共n个人,问哪个经纪人能最快的传播谣言,然后输出那个人的编号和所散播谣言的最短时间, 假如每个点都无法全部散播的话则输出 &quot;disjoint&quot; 题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPX55DM.html" rel="bookmark" class="title">express&lowbar;ca9x4 uboot分析</a>
					<div>
						1.vexpress-ca9x4和qemu介绍 vexpress-ca9x4是arm公司的模拟开发板, 官方资料是: ARM? CoreTile Express A9×4 Technical Refe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j9EjeM.html" rel="bookmark" class="title">VB&period;net shell、IO&period;File&period;Open、Process&period;Start、Shellexecute API 运用经验总结</a>
					<div>
						打开文件还有很多方法,但我了解到运用较多的是上面几种- -,为了防止以后忘记,先把了解到的写下来. 1.Shell 这个看了很多网页,最靠谱的运用方法: Shell(&quot;cmd.exe /c  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41yGlJ4.html" rel="bookmark" class="title">Jersey&lpar;1&period;19&period;1&rpar; - Using filters</a>
					<div>
						Filtering requests and responses can provide useful functionality that is hidden from the applicatio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q8Kv50.html" rel="bookmark" class="title">IOS对&period;Net返回的Base64string解析问题</a>
					<div>
						1.c#生成Base64字符串的代码 string body = &quot;{\&quot;title\&quot;:\&quot;上次CVR卡其\&quot;,\&quot;url\&quot;: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/472VBY3.html" rel="bookmark" class="title">安卓天天练练（十二）进度条</a>
					<div>
						又是一个安卓自带的方便控件,不用我html/css/js自己写了. 用可视化面板拖进去以后 &lt;RelativeLayout xmlns:android=&quot;http://schemas. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xxP2B0.html" rel="bookmark" class="title">Android TextView常用属性介绍Android&colon;drawableEnd</a>
					<div>
						//TextView所呈现的文字 android:text=&quot;我爱Java&quot; //文字颜色 android:textColor=&quot;#f00&quot; //文字尺寸 an ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
